c **** subroutine: nuvel1a.for **** Version: 26 Sep 2003 ***************
c Calculate NUVEL-1A absolute plate motion velocity vector at a 
c   specified locale on the Earth's surface.
c   Adapted from subroutine nnr by Kristine Larson.
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine nuvel1a(plt,r,v)
      implicit none
c
c  Arguments:
c
      character*4 plt
      real*8 r(3),v(3)
c
c  Local variables:
c
      integer i,iplt
      real*8 dtr,orx,ory,orz,pi,sfact
c
c Specification of model NUVEL1-NNR
c
      integer nplt
      parameter (nplt=14)
      character*4 pnm(nplt)
      real*8 omx(nplt),omy(nplt),omz(nplt)
      save pnm,omx,omy,omz
      data (pnm(i),omx(i),omy(i),omz(i),i=1,nplt)
     &   /'AFRC', 0.0532d0,-0.1855d0, 0.2348d0,
     &    'ANTA',-0.0494d0,-0.1018d0, 0.2218d0,
     &    'ARAB', 0.4003d0,-0.0311d0, 0.4049d0,
     &    'AUST', 0.4695d0, 0.3072d0, 0.3762d0,
     &    'CARB',-0.0109d0,-0.2027d0, 0.0945d0,
     &    'COCO',-0.6249d0,-1.2944d0, 0.6544d0,
     &    'EURA',-0.0590d0,-0.1434d0, 0.1887d0,
     &    'INDI', 0.3994d0, 0.0026d0, 0.4066d0,
     &    'NAZC',-0.0921d0,-0.5138d0, 0.5756d0,
     &    'NOAM', 0.0152d0,-0.2155d0,-0.0094d0,
     &    'PCFC',-0.0907d0, 0.2902d0,-0.5976d0,
     &    'SOAM',-0.0624d0,-0.0906d0,-0.0523d0,
     &    'FUCA', 0.2995d0, 0.4805d0,-0.2936d0,
     &    'PHIL', 0.5913d0,-0.4412d0,-0.5976d0/
c General constants:
      pi=3.141592653589793d0
      dtr=pi/1.8d2
c
      iplt=-1
c Factor to convert NUVEL-1 to NUVEL-1A:
      sfact=0.9562d0
c Plate look-up:
      do i=1,nplt
        if(plt.eq.pnm(i))iplt=i
      enddo
c Return zero velocity if plate name is not recognized:
      if(iplt.eq.-1)return
c Convert from degree/my to m/yr:
      orx=omx(iplt)*sfact*dtr*1d-6
      ory=omy(iplt)*sfact*dtr*1d-6
      orz=omz(iplt)*sfact*dtr*1d-6
c
      v(1)=ory*r(3)-orz*r(2)
      v(2)=orz*r(1)-orx*r(3)
      v(3)=orx*r(2)-ory*r(1)
c
      return
      end
c
