c **** subroutine: xyzenu.for **** Version: 12 Jun 2005 ****************
c Transform from XYZ to a local ENU (East-North-Up) coordinate frame, 
c   defined at the longitude/latitude of the site.
c   Adapted from subroutine xyz2enu by Kristine Larson.
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine xyzenu(xyz,ll,enu)
      implicit none
c
c  Arguments:
c
      real*8 enu(3),ll(3),xyz(3)
c
c  Local variables:
c
      real*8 t(3,3)
      integer i,j
c
c Transformation matrix for the given longitude/latitude:
      t(1,1)=-dsin(ll(1))
      t(1,2)=dcos(ll(1))
      t(1,3)=0d0
      t(2,1)=-dsin(ll(2))*dcos(ll(1))
      t(2,2)=-dsin(ll(2))*dsin(ll(1))
      t(2,3)=dcos(ll(2))
      t(3,1)=dcos(ll(2))*dcos(ll(1))
      t(3,2)=dcos(ll(2))*dsin(ll(1))
      t(3,3)=dsin(ll(2))
c
c Transform:
      do i=1,3
        enu(i)=0d0
        do j=1,3
          enu(i)=enu(i)+t(i,j)*xyz(j)
        enddo
      enddo
c
      return
      end
