c ***** Program: calcorr.for ***** Date: 26 Sep 2003 *******************
c  Read in files containing GPS site locations and calculate the 
c    correction for the North America intraplate motion component of 
c    the baseline velocity.
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      program calcorr
      implicit none
      include 'parper.inc'
c
c  Local variables:
c
      character sta(0:nsmx)*4
      integer i,j,ns
      real*8 ellh(3,0:nsmx),ll(3),rxyz(3),v0(3),vxyz(3)
      real*8 a1,b1,dtr,N,pi
c
C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c General constants:
      pi=3.141592653589793d0
      dtr=pi/1.8d2
c WGS-84 ellipsoid:
      a1=6.378137d6
      b1=6.356752314d6
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c THIS MUST BE CHANGED TO USE YOUR DESIRED REFERENCE SITE
c Primary Reference station Name/Coordinates
      sta(0)='MDO1'
      ellh(1,0)=255.9850085658d0*dtr
      ellh(2,0)=(9d1-30.6805117662d0)*dtr
      ellh(3,0)=2004.5099977748d0
c THIS MUST BE CHANGED TO USE YOUR DESIRED REFERENCE SITE
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c Read in GPS site locations:
      open(2,file='GPS_locs.dat',status='old')
      rewind(2)
      ns=0
1     read(2,'(3f19.11,2x,a4)',end=2)ellh(1,ns+1),ellh(2,ns+1),
     &    ellh(3,ns+1),sta(ns+1)
        ns=ns+1
        ellh(1,ns)=(3.6d2+ellh(1,ns))*dtr
        ellh(2,ns)=(9d1-ellh(2,ns))*dtr
      goto1
2     close(2)
c
      if(ns.gt.nsmx)then
        write(6,*)'Number of baselines: ',ns,' exceeds the max array ',
     &      'declaration: ',nsmx
        stop
      endif
c
      open(1,file='NOAM.corr',status='unknown')
      rewind(1)
c Calculate intraplate component of baseline velocity:
c Base station:
      do j=1,ns
        ll(1)=ellh(1,0)
        ll(2)=(pi/2d0)-ellh(2,0)
        ll(3)=ellh(3,0)
        N=a1*a1/dsqrt((a1*dcos(ll(2)))**2+(b1*dsin(ll(2)))**2)
        rxyz(1)=(N+ll(3))*dcos(ll(2))*dcos(ll(1))
        rxyz(2)=(N+ll(3))*dcos(ll(2))*dsin(ll(1))
        rxyz(3)=((b1*b1/(a1*a1))*N+ll(3))*dsin(ll(2))
        call nuvel1a('NOAM',rxyz,v0)
c Relative site:
        ll(1)=ellh(1,j)
        ll(2)=(pi/2d0)-ellh(2,j)
        ll(3)=ellh(3,j)
        N=a1*a1/dsqrt((a1*dcos(ll(2)))**2+(b1*dsin(ll(2)))**2)
        rxyz(1)=(N+ll(3))*dcos(ll(2))*dcos(ll(1))
        rxyz(2)=(N+ll(3))*dcos(ll(2))*dsin(ll(1))
        rxyz(3)=((b1*b1/(a1*a1))*N+ll(3))*dsin(ll(2))
        call nuvel1a('NOAM',rxyz,vxyz)
        do i=1,3
          vxyz(i)=vxyz(i)-v0(i)
        enddo
        call xyzenu(vxyz,ll,v0)
c Write the correction to a file:
        write(1,'(3f12.5,2x,a4)')v0(1),v0(2),v0(3),sta(j)
      enddo
      close(1)
c
      end
c
